package com.jz.agent.service;


import com.google.gson.Gson;
import com.jz.agent.client.DmpDsAgentClient;
import com.jz.agent.client.DmpDsAgentClientBuilder;
import com.jz.agent.client.service.DmpHdfsAgentClientService;
import com.jz.dmp.agent.DmpAgentResult;
import com.jz.dmp.modules.model.DmpAgentDatasourceInfo;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

@Service
public class DmpDsAgentServiceImp implements DmpDsAgentService {

    private Gson gson = new Gson();
    private static Logger logger = LoggerFactory.getLogger(DmpDsAgentServiceImp.class);

    public DmpAgentResult testConnect(DmpAgentDatasourceInfo ds) {
        logger.info("testConnect << REQUEST[DmpAgentDatasourceInfo=" + gson.toJson(ds) + "]");
        DmpDsAgentClient client = DmpDsAgentClientBuilder.build(ds);
        DmpAgentResult dar = client.testConnect(ds);
        logger.info("testConnect >> RESPONSE[" + gson.toJson(dar) + "]");
        return dar;
    }

    public DmpAgentResult getTableNameList(DmpAgentDatasourceInfo ds) {
        logger.info("getTableNameList << REQUEST[DmpAgentDatasourceInfo=" + gson.toJson(ds) + "]");
        DmpDsAgentClient client = DmpDsAgentClientBuilder.build(ds);
        DmpAgentResult dar = client.getTableNameList(ds);
        logger.info("getTableNameList >> RESPONSE[" + gson.toJson(dar) + "]");
        return dar;
    }

    public DmpAgentResult getTableColumnList(DmpAgentDatasourceInfo ds, String table) {
        logger.info("getTableColumnList << REQUEST[DmpAgentDatasourceInfo=" + gson.toJson(ds) + ", table=" + table + "]");
        DmpDsAgentClient client = DmpDsAgentClientBuilder.build(ds);
        DmpAgentResult dar = client.getTableColumnList(ds, table);
        logger.info("getTableColumnList >> RESPONSE[" + gson.toJson(dar) + "]");
        return dar;
    }

    public DmpAgentResult previewData(DmpAgentDatasourceInfo ds, String table) {
        logger.info("previewData << REQUEST[DmpAgentDatasourceInfo=" + gson.toJson(ds) + ", table=" + table + "]");
        DmpDsAgentClient client = DmpDsAgentClientBuilder.build(ds);
        DmpAgentResult dar = client.previewData(ds, table);
        logger.info("previewData >> RESPONSE[" + gson.toJson(dar) + "]");
        return dar;
    }

    public DmpAgentResult submitSycingXmlConfig(DmpAgentDatasourceInfo ds, String xml) {
        logger.info("submitSycingXmlConfig << REQUEST[DmpAgentDatasourceInfo=" + gson.toJson(ds) + ", table=" + xml + "]");
        DmpHdfsAgentClientService client = new DmpHdfsAgentClientService();
        DmpAgentResult dar = client.submitSycingConfig(ds, xml);
        logger.info("submitSycingXmlConfig >> RESPONSE[" + gson.toJson(dar) + "]");
        return dar;
    }

}
